From: Shile Zhang <shile.zhang@linux.alibaba.com>
To: Peter Zijlstra <peterz@infradead.org>,
Josh Poimboeuf <jpoimboe@redhat.com>,
Masahiro Yamada <yamada.masahiro@socionext.com>,
Michal Marek <michal.lkml@markovi.net>,
Thomas Gleixner <tglx@linutronix.de>,
Ingo Molnar <mingo@redhat.com>, Borislav Petkov <bp@alien8.de>,
Andy Lutomirski <luto@amacapital.net>,
x86@kernel.org
Cc: "H . Peter Anvin" <hpa@zytor.com>,
linux-kernel@vger.kernel.org, linux-kbuild@vger.kernel.org,
Shile Zhang <shile.zhang@linux.alibaba.com>
Subject: [RFC PATCH v6 7/7] x86/unwind/orc: remove run-time ORC unwind tables sort
Date: Wed, 4 Dec 2019 08:46:33 +0800 [thread overview]
Message-ID: <20191204004633.88660-8-shile.zhang@linux.alibaba.com> (raw)
In-Reply-To: <20191204004633.88660-1-shile.zhang@linux.alibaba.com>
The orc_unwind and orc_unwind_ip tables are sorted in vmlinux link phase
at build time, just remove the run-time sort.
Signed-off-by: Shile Zhang <shile.zhang@linux.alibaba.com>
Acked-by: Peter Zijlstra (Intel) <peterz@infradead.org>
---
arch/x86/kernel/unwind_orc.c | 8 +++++---
scripts/link-vmlinux.sh | 5 ++++-
2 files changed, 9 insertions(+), 4 deletions(-)
diff --git a/arch/x86/kernel/unwind_orc.c b/arch/x86/kernel/unwind_orc.c
index 332ae6530fa8..280da6fa9922 100644
--- a/arch/x86/kernel/unwind_orc.c
+++ b/arch/x86/kernel/unwind_orc.c
@@ -273,9 +273,11 @@ void __init unwind_init(void)
return;
}
- /* Sort the .orc_unwind and .orc_unwind_ip tables: */
- sort(__start_orc_unwind_ip, num_entries, sizeof(int), orc_sort_cmp,
- orc_sort_swap);
+ /*
+ * Note, orc_unwind and orc_unwind_ip tables has been sorted in
+ * vmlinux link phase by sorttable tool at build time.
+ * Its ready for binary search now.
+ */
/* Initialize the fast lookup table: */
lookup_num_blocks = orc_lookup_end - orc_lookup;
diff --git a/scripts/link-vmlinux.sh b/scripts/link-vmlinux.sh
index 01978d1e4c13..f0f08e2bbcd5 100755
--- a/scripts/link-vmlinux.sh
+++ b/scripts/link-vmlinux.sh
@@ -300,7 +300,10 @@ vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
info SORTTAB vmlinux
- sorttable vmlinux
+ if ! sorttable vmlinux; then
+ echo >&2 Failed to sort kernel tables
+ exit 1
+ fi
fi
info SYSMAP System.map
--
2.24.0.rc2
next prev parent reply other threads:[~2019-12-04 0:46 UTC|newest]
Thread overview: 19+ messages / expand[flat|nested] mbox.gz Atom feed top
2019-12-04 0:46 [RFC PATCH v6 0/7] Speed booting by sorting ORC unwind tables at build time Shile Zhang
2019-12-04 0:46 ` [RFC PATCH v6 1/7] scripts/sortextable: Rewrite error/success handling Shile Zhang
2019-12-13 10:03 ` [tip: core/objtool] " tip-bot2 for Shile Zhang
2019-12-04 0:46 ` [RFC PATCH v6 2/7] scripts/sortextable: kernel coding style formating Shile Zhang
2019-12-13 10:03 ` [tip: core/objtool] scripts/sortextable: Clean up the code to meet the kernel coding style better tip-bot2 for Shile Zhang
2019-12-04 0:46 ` [RFC PATCH v6 3/7] scripts/sortextable: Remove dead code Shile Zhang
2019-12-13 10:03 ` [tip: core/objtool] " tip-bot2 for Shile Zhang
2019-12-04 0:46 ` [RFC PATCH v6 4/7] scripts/sortextable: refactor do_func() function Shile Zhang
2019-12-13 10:03 ` [tip: core/objtool] scripts/sortextable: Refactor the " tip-bot2 for Shile Zhang
2019-12-04 0:46 ` [RFC PATCH v6 5/7] scripts/sorttable: rename sortextable to sorttable Shile Zhang
2019-12-13 10:03 ` [tip: core/objtool] scripts/sorttable: Rename 'sortextable' to 'sorttable' tip-bot2 for Shile Zhang
2019-12-04 0:46 ` [RFC PATCH v6 6/7] scripts/sorttable: Add ORC unwind tables sort concurrently Shile Zhang
2019-12-13 10:03 ` [tip: core/objtool] scripts/sorttable: Implement build-time ORC unwind table sorting tip-bot2 for Shile Zhang
2019-12-04 0:46 ` Shile Zhang [this message]
2019-12-13 10:03 ` [tip: core/objtool] x86/unwind/orc: Remove boot-time ORC unwind tables sorting tip-bot2 for Shile Zhang
2019-12-13 6:03 ` [RFC PATCH v6 0/7] Speed booting by sorting ORC unwind tables at build time Shile Zhang
2019-12-13 10:02 ` Ingo Molnar
2019-12-16 3:07 ` Shile Zhang
2020-01-07 7:36 ` [tip: core/objtool] x86/unwind/orc: Fix !CONFIG_MODULES build warning tip-bot2 for Shile Zhang
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20191204004633.88660-8-shile.zhang@linux.alibaba.com \
--to=shile.zhang@linux.alibaba.com \
--cc=bp@alien8.de \
--cc=hpa@zytor.com \
--cc=jpoimboe@redhat.com \
--cc=linux-kbuild@vger.kernel.org \
--cc=linux-kernel@vger.kernel.org \
--cc=luto@amacapital.net \
--cc=michal.lkml@markovi.net \
--cc=mingo@redhat.com \
--cc=peterz@infradead.org \
--cc=tglx@linutronix.de \
--cc=x86@kernel.org \
--cc=yamada.masahiro@socionext.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).